package sun.java2d.pipe.hw;

import java.awt.ImageCapabilities;
import java.awt.BufferCapabilities;

public class ExtendedBufferCapabilities extends BufferCapabilities
{
    private ExtendedBufferCapabilities.VSyncType vsync;
    
    public ExtendedBufferCapabilities(BufferCapabilities bufferCapabilities) {
        super(bufferCapabilities.getFrontBufferCapabilities(), bufferCapabilities.getBackBufferCapabilities(), bufferCapabilities.getFlipContents());
        this.vsync = ExtendedBufferCapabilities.VSyncType.VSYNC_DEFAULT;
    }
    
    public ExtendedBufferCapabilities(ImageCapabilities frontCaps, ImageCapabilities backCaps, BufferCapabilities.FlipContents flipContents) {
        super(frontCaps, backCaps, flipContents);
        this.vsync = ExtendedBufferCapabilities.VSyncType.VSYNC_DEFAULT;
    }
    
    public ExtendedBufferCapabilities(ImageCapabilities frontCaps, ImageCapabilities backCaps, BufferCapabilities.FlipContents flipContents, ExtendedBufferCapabilities.VSyncType vsync) {
        super(frontCaps, backCaps, flipContents);
        this.vsync = vsync;
    }
    
    public ExtendedBufferCapabilities(BufferCapabilities bufferCapabilities, ExtendedBufferCapabilities.VSyncType vsync) {
        super(bufferCapabilities.getFrontBufferCapabilities(), bufferCapabilities.getBackBufferCapabilities(), bufferCapabilities.getFlipContents());
        this.vsync = vsync;
    }
    
    public ExtendedBufferCapabilities derive(ExtendedBufferCapabilities.VSyncType vSyncType) {
        return new ExtendedBufferCapabilities(this, vSyncType);
    }
    
    public ExtendedBufferCapabilities.VSyncType getVSync() {
        return this.vsync;
    }
    
    @Override
    public final boolean isPageFlipping() {
        return true;
    }
    
    public enum VSyncType
    {
        VSYNC_DEFAULT(0), 
        VSYNC_ON(1), 
        VSYNC_OFF(2);
        
        private int id;
        
        public int id() {
            return this.id;
        }
        
        private VSyncType(int id) {
            this.id = id;
        }
    }
}
